﻿'UTF-8
Option Strict On

Friend Class ucImageView

    Private Const INFOFORMAT As String = "Filename: {0}, FileSize: {1}KByte, Width: {2}px, Height: {3}px"

    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        If (Me.OFD.ShowDialog(Me) <> System.Windows.Forms.DialogResult.OK) Then Return

        Dim filename As String = Me.OFD.FileName
        If (String.IsNullOrEmpty(filename)) Then Return

        Dim img As System.Drawing.Image
        Try
            img = System.Drawing.Image.FromFile(filename)
            If (img Is Nothing) Then Return
        Catch ex As Exception
            System.Windows.Forms.MessageBox.Show(Me, ex.Message, "Error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error)
            Return
        End Try
        '------------------------------------------------------------
        Me.PB.Visible = True
        Me.f_Zoom_1.Enabled = True
        Me.f_Zoom_2.Enabled = True

        Me.lblInfo.Text = String.Format(INFOFORMAT, _
            System.IO.Path.GetFileName(filename), _
            Microsoft.VisualBasic.FileSystem.FileLen(filename) \ 1024, _
            img.Width, _
            img.Height)

        If (Me.PB.Image IsNot Nothing) Then
            Me.PB.Image.Dispose()
        End If

        Me.PB.Image = img
        Me.RefreshZoom()
    End Sub

    Private Sub f_Zoom_1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles f_Zoom_1.ValueChanged
        If (Me.f_Zoom_2.Value <> Me.f_Zoom_1.Value) Then
            Me.f_Zoom_2.Value = Me.f_Zoom_1.Value
            Me.RefreshZoom()
        End If
    End Sub

    Private Sub f_Zoom_2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles f_Zoom_2.ValueChanged
        If (Me.f_Zoom_1.Value <> Me.f_Zoom_2.Value) Then
            Me.f_Zoom_1.Value = CInt(Me.f_Zoom_2.Value)
            Me.RefreshZoom()
        End If
    End Sub

    Private Sub RefreshZoom()
        If (Me.PB.Image Is Nothing) Then
            '...
            Return
        End If
        '------------------------------------------------------------
        Dim zoom As Integer = Me.f_Zoom_1.Value
        Dim imgsize As System.Drawing.Size = Me.PB.Image.Size

        Me.PB.Size = _
            New System.Drawing.Size( _
            imgsize.Width * zoom \ 100, _
            imgsize.Height * zoom \ 100)

        '
        'Or ...
        '
        'Me.PB.Size = _
        '    New System.Drawing.Size( _
        '    Me.PB.Image.Width * Me.f_Zoom_1.Value \ 100, _
        '    Me.PB.Image.Height * Me.f_Zoom_1.Value \ 100)
    End Sub

End Class
